
<template>
    <content-layout>
        <template v-slot:header>
            <h1>Usuarios</h1>
        </template>
        <div class="container-fluid">
            <div class="card">
                <div class="card-header">
                    <div class="float-left">
                        <h3 class="card-title">Listado de usuarios</h3>
                    </div>
                    <div class="float-right">
                        <a href="#" class="btn btn-primary" v-on:click="createUser"><i class="fa fa-plus-square"></i> Crear usuario</a>
                    </div>
                    <div class="clearfix"></div>
                </div>
                <div class="card-body">
                    <div class="form-inline table-filters">
                        <div class="form-group">
                            <label for="full_name" class="control-label">Nombre</label>
                            <v-select label="full_name" :filterable="false" :options="users" taggable
                                    :create-option="option => ({ full_name: option })"
                                    @search="searchUser" v-model="params.full_name"
                                    :reduce="user => user.full_name" style="width: 250px">
                                <template slot="no-options">
                                    Buscar usuarios
                                </template>
                                <template slot="option" slot-scope="option">
                                    <div class="d-center">
                                        {{ option.full_name }}
                                    </div>
                                </template>
                                <template slot="selected-option" slot-scope="option">
                                    <div class="selected d-center">
                                        {{ option.full_name }}
                                    </div>
                                </template>
                            </v-select>
                        </div>
                        <div class="form-group">
                            <label for="email" class="control-label">Correo electrónico</label>
                            <v-select label="email" :filterable="false" :options="users" taggable
                                    :create-option="option => ({ email: option })"
                                    @search="searchByEmail" v-model="params.email"
                                    :reduce="user => user.email" style="width: 250px">
                                <template slot="no-options">Buscar e-mails</template>
                                <template slot="option" slot-scope="option">
                                    <div class="d-center">
                                        {{ option.email }}
                                    </div>
                                </template>
                                <template slot="selected-option" slot-scope="option">
                                    <div class="selected d-center">
                                        {{ option.email }}
                                    </div>
                                </template>
                            </v-select>
                        </div>
                        <div class="form-group">
                            <button class="btn btn-secondary" v-on:click="reload"><i class="fa fa-search"></i> Filtrar</button>
                        </div>
                    </div>
                    <div class="table-responsive">
                        <vuetable ref="vuetable" class="users-table"
                                api-url="/ajax/users"
                                v-bind:fields="fields"
                                v-bind:sort-order="sortOrder"
                                v-bind:append-params="params"
                                v-bind:css="css.table"
                                pagination-path=""
                                v-bind:per-page="20"
                                @vuetable:pagination-data="onPaginationData"
                                @vuetable:loading="onLoading"
                                @vuetable:loaded="onLoaded"
                                @vuetable:load-error="handleLoadError">
                            <template slot="actions" slot-scope="props">
                                <div class="table-button-container text-center">
                                    <button class="btn btn-success btn-sm" v-bind:class="{
                                                'btn-warning': props.rowData.is_active == 0
                                            }"
                                            @click="activateUser(props.rowData)"
                                            title="Cambiar estatus">
                                        <i class="fa fa-check"></i>
                                    </button>
                                    <button class="btn btn-info btn-sm" @click="editUser(props.rowData, true)"
                                            title="Editar usuario">
                                        <i class="fa fa-pencil-alt"></i>
                                    </button>
                                    <button class="btn btn-danger btn-sm" @click="deleteRow(props.rowData)"
                                            title="Borrar usuario">
                                        <i class="fa fa-trash"></i>
                                    </button>
                                </div>
                            </template>
                        </vuetable>
                    </div>
                    <vuetable-pagination ref="pagination" v-bind:css="css.pagination"
                            @vuetable-pagination:change-page="onChangePage">
                    </vuetable-pagination>
                </div>
            </div>
        </div>
        <b-modal id="user-modal" ref="userModal" v-bind:title="title" ok-only 
                 @hidden="onUsersModalHidden" v-bind:static="true">
            <user-form ref="userForm"></user-form>
            <div slot="modal-footer" class="w-100">
                <b-button variant="primary" class="float-right" @click="saveUser">
                    Guardar
                </b-button>
            </div>
        </b-modal>
    </content-layout>
</template>

<script>
import Content from '../../layouts/Content.vue';
import Vuetable from 'vuetable-2';
import VuetablePagination from 'vuetable-2/src/components/VuetablePagination.vue';
import UserForm from './Form.vue';
import TableMixin from '../../mixins/TableMixin.vue';
import auth from '../../auth.js';
import settings from '../../settings.js';
import utils from '../../utils.js';
import vSelect from 'vue-select';

export default {
    mixins: [TableMixin],
    components: {
        'content-layout': Content,
        'vuetable': Vuetable,
        'vuetable-pagination': VuetablePagination,
        'user-form': UserForm,
        'v-select': vSelect
    },
    data() {
        return {
            fields: [
                {
                    name: 'full_name',
                    title: "Nombre",
                    sortField: 'full_name'
                },
                {
                    name: 'email',
                    title: "Correo electrónico",
                    sortField: 'email'
                },
                '__slot:actions'
            ],
            sortOrder: [
                {
                    field: 'full_name', direction: 'asc'
                }
            ],
            css: settings.vuetable.css,
            modal: {
                mode: 'create'
            },
            users: [],
            params: {
                full_name: null,
                email: null
            },
            saved: false
        };
    },
    computed: {
        title() {
            return this.modal.mode === 'create' ? "Crear usuario" : "Editar usuario";
        }
    },
    methods: {
        reload(e) {
            e.preventDefault();
            this.$refs.vuetable.refresh();
        },
        searchUser(search, loading) {
            if (search === null || search === void 0) {
                return;
            }
            if (search.length < 2) {
                return;
            }
            var vm = this;
            loading(true);
            axios.get('/ajax/users?no-paginate=1&full_name=' + encodeURIComponent(search))
            .then(function(response) {
                vm.users = response.data;
            })
            .catch(function(error) {
                //
            })
            .then(function() {
                loading(false);
            });
        },
        searchByEmail(search, loading) {
            if (search === null || loading === void 0) {
                return;
            }
            if (search.length < 2) {
                return;
            }
            var vm = this;
            axios.get('/ajax/users?no-paginate=1&email=' + encodeURIComponent(search))
            .then(function(response) {
                vm.users = response.data;
            })
            .catch(function(error) {

            })
            .then(function() {
                loading(false);
            });
        },
        createUser(e) {
            e.preventDefault();
            this.modal.mode = 'create';
            this.saved = false;
            this.$refs.userForm.create();
            this.showUserModal();
        },
        editUser(record, addHistory) {
            this.saved = false;
            if (addHistory === void 0) {
                addHistory = false;
            }
            if (addHistory) {
                this.$router.push({ name: 'users.edit', params: { id: record.id } });
            }
            this.$refs.userForm.edit(record);
            this.modal.mode = 'edit';
            this.showUserModal();
        },
        deleteRow(record) {
            this.deleteRecord({
                title: "Eliminar usuario",
                message: "¿Estás seguro de eliminar el usuario " + record.full_name + "?",
                url: '/ajax/users/' + record.id
            });
        },
        activateUser(record) {
            this.activateRecord({
                title: (record.is_active == 1 ? 'Desactivar' : 'Activar') + ' usuario',
                message: '¿Estás seguro de ' + (record.is_active == 1 ? 'desactivar' : 'activar') + ' el usuario ' + record.full_name + "?",
                url: '/ajax/users/' + record.id + '/activate'
            });
        },
        showUserModal() {
            this.$refs.userForm.resetErrors();
            this.$refs.userModal.show();
        },
        saveUser() {
            var vm = this;
            $(this.$refs.userModal.$el).find('.modal-content').busyLoad('show', {
                background: 'rgba(255, 255, 255, 0.7)',
                color: '#000000'
            });
            this.$refs.userForm.saveModel(function() {
                vm.saved = true;
                vm.$refs.userModal.hide();
            }, function() {
                $(vm.$refs.userModal.$el).find('.modal-content').busyLoad('hide');
            }, function() {
                $(vm.$refs.userModal.$el).find('.modal-content').busyLoad('hide');
            });
        },
        onLoaded() {
            // Ocultar loader
            $(this.$refs.vuetable.$el).busyLoad('hide');
            NProgress.done();
            // Si es la ruta de edición de usuarios
            if (this.$route.name === 'users.edit') {
                // Buscar registro del usuario solicitado
                this.enterToEditRoute(this.$route);
            }
        },
        enterToEditRoute(route) {
            var vm = this;
            axios.get('/ajax/users/' + route.params.id)
            .then(function (response) {
                vm.editUser(response.data);
            })
            .catch(function (error) {
                //
            });
        },
        onUsersModalHidden() {
            if (this.saved) {
                this.$refs.vuetable.reload();
            }
            if (this.$route.name === 'users.edit') {
                this.$router.push({ name: 'users' });
            }
        }
    },
    mounted() {
        document.head.querySelector('title').text = "Usuarios" + " - " + settings.title;
        $(this.$refs.userModal.$el).find('.modal-body').css('max-height', settings.modalHeight);
        var vm = this;
        this.$nextTick(() => {
            // Modificar título de la columna de acciones después de la carga completa de la vista
            $(vm.$refs.vuetable.$el)
                    .find('thead th.vuetable-th-slot-actions')
                    .text("Acciones");
        });
    },
    watch: {
        '$route' (to, from) {
            if (to.name === 'users.edit') {
                this.enterToEditRoute(to);
            }
        }
    }
};
</script>

<style>
    .users-table thead th.vuetable-th-slot-actions {
        width: 150px !important;
    }
</style>